  /*
 * Copyright (c) 1998-2007 TeamDev Ltd. All Rights Reserved.
 * Use is subject to license terms.
 */

function q__initEventHandler() {
  if (document.q__clickHandler) {
    return;
  }
  document.q__clickHandler = q__popupClicked;
  var _clickHandler = q__getEventHandlerFunction('q__clickHandler', null, document);
  document._addClickListener(_clickHandler);
}

q__initEventHandler();

function q__initPopup(popupId, useDisplayNoneByDefault) {
  var popup = q__getControl(popupId);

  if (!document.Q__POPUPS_ON_PAGE) {
    document.Q__POPUPS_ON_PAGE = new Array();
  }
  document.Q__POPUPS_ON_PAGE[document.Q__POPUPS_ON_PAGE.length] = popupId;
  if (useDisplayNoneByDefault) {
    if (popup._originalStyleDisplay == undefined)
      popup._originalStyleDisplay = popup.style.display;
    popup.style.display = "none";
  }
  popup._visibilityChangeListeners = null;
  popup._addVisibilityChangeListener = function(listenerObjectFunction) {
    if (!this._visibilityChangeListeners) {
      this._visibilityChangeListeners = new Array();
    }
    this._visibilityChangeListeners[this._visibilityChangeListeners.length] = listenerObjectFunction;
  }


  /*
    popup.setLeft = function(left) {
      this.style.left = left + "px";
    }

    popup.setTop = function(top) {
      this.style.top = top + "px";
    }
  */
  popup.setLeft = function (left) {
    if (q__isExplorer()) {
      var outerDiv = popup._outerIEDiv;
      if (outerDiv) {
        outerDiv.style.left = left + "px";
      } else {
        popup.style.left = left + "px";
      }
    } else {
      popup.style.left = left + "px";
    }
  }

  popup.setTop = function (top) {
    if (q__isExplorer()) {
      var outerDiv = popup._outerIEDiv;
      if (outerDiv) {
        outerDiv.style.top = top + "px";
      } else {
        popup.style.top = top + "px";
      }
    } else {
      popup.style.top = top + "px";
    }
  }

  popup._prepareForRearrangementBeforeShowing = function() {
    if (this.isVisible())
      return;
    if (this.style.display == "none")
      this.style.display = this._originalStyleDisplay;
  }

  popup.show = function() {
    if (this.isVisible())
      return;

    if (q__isExplorer())
      popup._ieDragControlCreationTimeout = setTimeout(function() {
        popup._ieDragControlCreationTimeout = undefined;
        q__createIEDragControl(popup);
      }, 10);

    //    q__hideControlsUnderPopup(this);
    this.style.visibility = "visible";
    if (this.style.display == "none")
      this.style.display = this._originalStyleDisplay;
    q__popup_notifyVisibilityChangeListeners(this.id);
  }

  popup.hide = function() {
    if (!this.isVisible())
      return;

    if (popup._ieDragControlCreationTimeout) {
      popup._ieDragControlCreationTimeout = undefined;
      clearTimeout(popup._ieDragControlCreationTimeout);
    }
    
    if (q__isExplorer())
      q__removeIEDragControl(this);

    //      q__unhideControlsUnderPopup(this);
    this.style.visibility = "hidden";
    if (this._originalStyleDisplay == undefined)
      this._originalStyleDisplay = this.style.display;
    var mozilla = q__isMozilla() && !q__isExplorer();
    if (mozilla) {
      var oldOverflow = q__calculateStyleProperty(this, "overflow");
      this.style.overflow = "hide"; // to avoid regaining focus when tabbing out from an opened DropDownField under Mozilla
      setTimeout(function() { // time-out is needed for Mozilla when selecting an item in DropDownField (JSFC-2620)
        popup.style.display = "none";
        popup.style.overflow = oldOverflow;
      }, 1);
    } else {
      this.style.display = "none";
    }
    q__popup_notifyVisibilityChangeListeners(this.id);
  }

  popup.isVisible = function() {
    var visible = (this.style.visibility == "visible") && (this.style.display != "none");
    return visible;
  }
}

function q__popup_notifyVisibilityChangeListeners(popupId) {
  var popup = q__getControl(popupId);
  var listeners = popup._visibilityChangeListeners;
  if (listeners && listeners.length > 0) {
    for (var i = 0; i < listeners.length; i ++) {
      listeners[i](popup.isVisible());
    }
  }
}

function q__popupClicked(e) {
  var evt = q__getEvent(e);
  if (!evt) return;

  var clickedElement;
  if (evt.target) {
    clickedElement = evt.target;
  } else {
    clickedElement = evt.srcElement;
  }

  var clickedElementId = clickedElement.id;

  if (document.Q__POPUPS_ON_PAGE)
    for (var i = 0, count = document.Q__POPUPS_ON_PAGE.length; i < count; i ++) {
      var popupId = document.Q__POPUPS_ON_PAGE[i];
      var popup = q__getControl(popupId);
      if (!popup)
        continue; // popup can be removed from page with A4J
      var clickedOnChild = q__isChild(popup, clickedElement);
      if (popupId == clickedElementId || clickedOnChild)
        continue;
      popup.hide();
    }
}

function q__hideAllPopupsExceptOne(popupToRetain) {
  if (!document.Q__POPUPS_ON_PAGE)
    return;
  for (var i = 0, count = document.Q__POPUPS_ON_PAGE.length; i < count; i ++) {
    var popupId = document.Q__POPUPS_ON_PAGE[i];
    var currPopup = q__getControl(popupId);
    if (!currPopup)
      continue; // popup can be removed from page with A4J
    if (currPopup != popupToRetain)
      currPopup.hide();
  }
}
